﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication228
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataTable dt = new DataTable();
            dt.Columns.Add();
            dt.Columns.Add();
            dt.Rows.Add(new object[] { "1" });

            DataTable dt1 = new DataTable();
            dt1.Columns.Add();
            dt1.Columns.Add();
            dt1.Rows.Add();
            dt1.Rows.Add(new object[] { "1", "" });

            DataSet ds = new DataSet();
            ds.Tables.Add(dt);
            ds.Tables.Add(dt1);

            ds.Relations.Add(dt.Columns[0], dt1.Columns[0]);

            ultraGrid1.DataSource = ds;

            this.ultraGrid1.DisplayLayout.Override.SupportDataErrorInfo =
              SupportDataErrorInfo.RowsAndCells;
            this.ultraGrid1.DisplayLayout.Override.DataErrorCellAppearance.BackColor = Color.Red;
            this.ultraGrid1.DisplayLayout.Override.DataErrorRowSelectorAppearance.BackColor = Color.Red;
            this.ultraGrid1.DisplayLayout.Override.DataErrorRowAppearance.BackColor = Color.LightYellow;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            Object value = "";
            string rowError = "";
            string cellError = "";
            if (e.Row.ParentRow != null)
            {
                value = e.Row.Cells[1].Value;
                if ("1" == value.ToString())
                {
                    rowError = "Row contains errors.";
                    cellError = "Fax can not be empty";
                }

                DataRowView drv = (DataRowView)e.Row.ParentRow.ListObject;
                drv.Row.RowError = rowError;
                drv.Row.SetColumnError(0, cellError);
            }
        }
    }
}
